<script lang="ts">
	import { onDestroy, onMount } from 'svelte';
	import { basePath, ws } from '$lib/config';
	import type { Donor } from '$lib/donors';
	import { Howl } from 'howler';
	import ReconnectingWebSocket from 'reconnecting-websocket';

	let displayedObj: { d: Donor; t: string } | null;

	let formatter = new Intl.NumberFormat('fr-FR', {
		style: 'currency',
		currency: 'EUR'
	});
	let snds = [
		new Howl({ src: [basePath() + 'assets/goal1.wav'] }),
		new Howl({ src: [basePath() + 'assets/goal2.wav'] }),
		new Howl({ src: [basePath() + 'assets/goal3.wav'] })
	];
	let largeSound = new Howl({ src: [basePath() + 'assets/Large.wav'] });

	let fifo: { d: Donor; t: string }[] = [];
	let fifoRunning: number | null;

	let timeout: number = 0;

	let nameLetters: string[];
	let text1Letters: string[] = 'a donné'.split('');
	let amountLetters: string[];

	// Quand tu recois un message tu le append dans fifo :
	function receiveDon(don: { d: Donor; t: string }) {
		fifo.push(don);
		runFifo();
	}

	function runFifo() {
		if (fifoRunning) return;
		fifoRunning = setInterval(doSomething, 100);
	}

	function doSomething() {
		// Ce que tu dois faire avec le dernier

		if (!timeout) {
			let don = fifo.shift();
			if (don) {
				displayedObj = null;
				text1Letters = [];
				nameLetters = [];
				amountLetters = [];

				setTimeout(() => {
					let duration = 5000;
					if (don) {
						don = don;
						if (don.d.amount >= 20000) {
							largeSound.play();
							duration = 13500;
						} else {
							let x = Math.floor(Math.random() * 3);
							snds[x].play();
							duration = 5000;
						}
						displayedObj = don;
						text1Letters = 'a donné'.split('');
						nameLetters = (displayedObj.d.first_name + ' ' + displayedObj.d.last_name).split('');
						amountLetters = formatter.format(displayedObj.d.amount / 100).split('');
					}
					timeout = setTimeout(() => {
						displayedObj = null;
						nameLetters = [];
						amountLetters = [];
						text1Letters = [];
						timeout = 0;
					}, duration);
				}, 2);
			}

			if (fifo.length === 0 && fifoRunning) {
				clearInterval(fifoRunning);
				fifoRunning = null;
			}
		}
	}

	onMount(async () => {
		// Start WS
		const socket = new ReconnectingWebSocket(ws());

		socket.addEventListener('open', function (event) {
			socket.send(JSON.stringify({ op: 'sub', msg: `teams.*.don` }));
		});

		socket.addEventListener('message', function (event) {
			let data = JSON.parse(event.data);
			switch (data.r) {
				case `teams.1.don`:
				case `teams.2.don`:
				case `teams.3.don`:
				case `teams.0.don`:
					receiveDon({ d: data.d.don, t: data.d.teamID });
					break;
				case `refresh`:
					// Refresh the page
					setTimeout(() => {
						window.location.reload();
					}, Math.random() * 1000);
					break;
			}
		});
		// // Uncomment this to test the widget without the backend
		// let p = 0;
		// setInterval(() => {
		// 	p += Math.random() * 1000;
		// 	receiveDon({
		// 		d: {
		// 			n: 1,
		// 			amount: 20000,
		// 			first_name: 'OUi',
		// 			id: '12',
		// 			last_name: 'Non',
		// 			time: 123123
		// 		},
		// 		t: 0
		// 	});
		// }, 1200);
	});

	onDestroy(() => {
		if (fifoRunning) {
			clearInterval(fifoRunning);
		}
	});
</script>

<div class="color flex flex-col w-screen h-screen items-center justify-center absolute top-0 -z-10">
	<div class="self-center">
		<div class="flex flex-col items-center text-7xl font-extrabold -mt-20">
			{#if displayedObj}
				<div class="flex flex-row gap-1" style="background-color:transparent">
					<div class="flex flex-row">
						{#each nameLetters as letter, i}
							<div 
								class="important-text letter-wave" 
								style:--i={i}
								style="{(nameLetters.length + text1Letters.length + amountLetters.length) > 25 ? 'font-size: 30px !important;' : ''};"
							>
								{#if /\s/.test(letter)}
									<div class="empty"></div>
								{:else}
									{letter}
								{/if}
							</div>
						{/each}
					</div>
					<div class="flex flex-row mx-3">
						{#each text1Letters as letter, i}
							<div 
								class="regular-text letter-wave" 
								style:--i={i + nameLetters.length}
								style="{(nameLetters.length + text1Letters.length + amountLetters.length) > 25 ? 'font-size: 30px !important;' : ''};"
							>
								{#if /\s/.test(letter)}
									<div class="empty"></div>
								{:else}
									{letter}
								{/if}
							</div>
						{/each}
					</div>
					<div class="flex flex-row">
						{#each amountLetters as letter, i}
							<div
								class="important-text letter-wave"
								style:--i={i + nameLetters.length + text1Letters.length}
								style="{(nameLetters.length + text1Letters.length + amountLetters.length) > 25 ? 'font-size: 30px !important;' : ''};"
							>
								{#if /\s/.test(letter)}
									<div class="empty"></div>
								{:else}
									{letter}
								{/if}
							</div>
						{/each}
					</div>
				</div>
			{/if}
		</div>
	</div>
</div>

<style>
	:global(body) {
		overflow: hidden;
		max-width: 100vw;
	}

	.important-text {
		font-family: Helvetica, sans-serif;
		font-size: 50px;
		color: #00537e;
		-webkit-text-stroke-width: 1px;
		-webkit-text-stroke-color: white;
	}
	.regular-text {
		font-family: Helvetica, sans-serif;
		color: #00537e;
		font-size: 50px;
		-webkit-text-stroke-width: 1px;
		-webkit-text-stroke-color: white;
	}
	.empty {
		content: '';
		font-size: 40px;
		width: 1ch;
	}

	.letter-wave {
		animation: waviy 3s infinite calc(0.05s * var(--i));
	}
	@keyframes waviy {
		0% {
			color: #00537e;
			transform: translateY(5px);
		}
		50% {
			color: #38a17e;
			transform: translateY(-10px);
		}
		100% {
			color: #00537e;
			transform: translateY(5px);
		}
	}
</style>
